Index: code/branches/input/src/core/input/InputManager.cc
===================================================================
--- code/branches/input/src/core/input/InputManager.cc	(revision 1636)
+++ code/branches/input/src/core/input/InputManager.cc	(revision 1637)
@@ -1157,8 +1058,8 @@
     void InputManager::setWindowExtents(const int width, const int height)
     {
-        if (_getSingleton().mouse_)
+        if (_getInstance().mouse_)
         {
             // Set mouse region (if window resizes, we should alter this to reflect as well)
-            const OIS::MouseState &mouseState = _getSingleton().mouse_->getMouseState();
+            const OIS::MouseState &mouseState = _getInstance().mouse_->getMouseState();
             mouseState.width  = width;
             mouseState.height = height;
@@ -1166,31 +1067,7 @@
     }
 
-    /**
-    @brief
-        Sets the input mode to either GUI, inGame or Buffer
-    @param mode
-        The new input mode
-    @remarks
-        Only has an affect if the mode actually changes
-    */
-    void InputManager::setInputState(const InputState state)
-    {
-        _getSingleton().stateRequest_ = state;
-    }
-
-    /**
-    @brief
-        Returns the current input handling method
-    @return
-        The current input mode.
-    */
-    InputManager::InputState InputManager::getInputState()
-    {
-        return _getSingleton().state_;
-    }
-
     void InputManager::storeKeyStroke(const std::string& name)
     {
-        setInputState(IS_NODETECT);
+        requestLeaveState("detector");
         COUT(0) << "Binding string \"" << bindingCommmandString_s << "\" on key '" << name << "'" << std::endl;
         CommandExecutor::execute("config KeyBinder " + name + " " + bindingCommmandString_s, false);
@@ -1200,5 +1077,5 @@
     {
         bindingCommmandString_s = command;
-        setInputState(IS_DETECT);
+        requestEnterState("detector");
         COUT(0) << "Press any button/key or move a mouse/joystick axis" << std::endl;
     }
@@ -1206,13 +1083,13 @@
     void InputManager::calibrate()
     {
-        _getSingleton().setInputState(IS_CALIBRATE);
+        requestEnterState("calibrator");
     }
 
     void InputManager::tick(float dt)
     {
-        _getSingleton()._tick(dt);
-    }
-
-    // ###### KeyHandler ######
+        _getInstance()._tick(dt);
+    }
+
+    // ###### InputStates ######
 
     /**
@@ -1226,15 +1103,56 @@
         True if added, false if name already existed.
     */
-    bool InputManager::addKeyHandler(KeyHandler* handler, const std::string& name)
-    {
-        if (!handler)
+    bool InputManager::_configureInputState(InputState* state, const std::string& name, int priority)
+    {
+        if (name == "")
             return false;
-        if (_getSingleton().keyHandlers_.find(name) == _getSingleton().keyHandlers_.end())
-        {
-            _getSingleton().keyHandlers_[name] = handler;
-            return true;
+        if (_getInstance().inputStatesByName_.find(name) == _getInstance().inputStatesByName_.end())
+        {
+            if (_getInstance().inputStatesByPriority_.find(priority)
+                == _getInstance().inputStatesByPriority_.end())
+            {
+                _getInstance().inputStatesByName_[name] = state;
+                _getInstance().inputStatesByPriority_[priority] = state;
+                state->setNumOfJoySticks(numberOfJoySticks());
+                state->setName(name);
+                state->setPriority(priority);
+                return true;
+            }
+            else
+            {
+                COUT(2) << "Warning: Could not add an InputState with the same priority '"
+                    << priority << "'." << std::endl;
+                return false;
+            }
         }
         else
+        {
+            COUT(2) << "Warning: Could not add an InputState with the same name '" << name << "'." << std::endl;
             return false;
+        }
+    }
+
+    SimpleInputState* InputManager::createSimpleInputState(const std::string &name, int priority)
+    {
+        SimpleInputState* state = new SimpleInputState();
+        if (_getInstance()._configureInputState(state, name, priority))
+            return state;
+        else
+        {
+            delete state;
+            return 0;
+        }
+    }
+
+    ExtendedInputState* InputManager::createExtendedInputState(const std::string &name, int priority)
+    {
+        ExtendedInputState* state = new ExtendedInputState();
+        if (_getInstance()._configureInputState(state, name, priority))
+            return state;
+        else
+        {
+            delete state;
+            return 0;
+        }
     }
 
@@ -1247,15 +1165,18 @@
         True if removal was successful, false if name was not found.
     */
-    bool InputManager::removeKeyHandler(const std::string &name)
-    {
-        disableKeyHandler(name);
-        std::map<std::string, KeyHandler*>::iterator it = _getSingleton().keyHandlers_.find(name);
-        if (it != _getSingleton().keyHandlers_.end())
-        {
-            _getSingleton().keyHandlers_.erase(it);
+    bool InputManager::destroyState(const std::string& name)
+    {
+        if (name == "empty" || name == "calibrator" || name == "detector")
+        {
+            COUT(2) << "InputManager: Removing the '" << name << "' state is not allowed!" << std::endl;
+            return false;
+        }
+        std::map<std::string, InputState*>::iterator it = _getInstance().inputStatesByName_.find(name);
+        if (it != _getInstance().inputStatesByName_.end())
+        {
+            _getInstance()._destroyState((*it).second);
             return true;
         }
-        else
-            return false;
+        return false;
     }
 
@@ -1268,11 +1189,22 @@
         Pointer to the instance, 0 if name was not found.
     */
-    KeyHandler* InputManager::getKeyHandler(const std::string& name)
-    {
-        std::map<std::string, KeyHandler*>::iterator it = _getSingleton().keyHandlers_.find(name);
-        if (it != _getSingleton().keyHandlers_.end())
+    InputState* InputManager::getState(const std::string& name)
+    {
+        std::map<std::string, InputState*>::iterator it = _getInstance().inputStatesByName_.find(name);
+        if (it != _getInstance().inputStatesByName_.end())
             return (*it).second;
         else
             return 0;
+    }
+
+    /**
+    @brief
+        Returns the current input handling method
+    @return
+        The current input mode.
+    */
+    InputState* InputManager::getCurrentState()
+    {
+        return (*_getInstance().activeStates_.rbegin()).second;
     }
 
@@ -1285,390 +1217,26 @@
         False if name was not found, true otherwise.
     */
-    bool InputManager::enableKeyHandler(const std::string& name)
+    bool InputManager::requestEnterState(const std::string& name)
     {
         // get pointer from the map with all stored handlers
-        std::map<std::string, KeyHandler*>::const_iterator mapIt = _getSingleton().keyHandlers_.find(name);
-        if (mapIt == _getSingleton().keyHandlers_.end())
-            return false;
-        // see whether the handler already is in the list
-        for (std::vector<KeyHandler*>::iterator it = _getSingleton().activeKeyHandlers_.begin();
-            it != _getSingleton().activeKeyHandlers_.end(); it++)
-        {
-            if ((*it) == (*mapIt).second)
-            {
-                return true;
-            }
-        }
-        _getSingleton().activeKeyHandlers_.push_back((*mapIt).second);
-        _getSingleton().stateRequest_ = IS_CUSTOM;
-        _getSingleton()._updateTickables();
-        return true;
-    }
-
-    /**
-    @brief
-        Disables a specific key handler.
-    @param name
-        Unique name of the handler.
-    @return
-        False if name was not found, true otherwise.
-    */
-    bool InputManager::disableKeyHandler(const std::string &name)
+        std::map<std::string, InputState*>::const_iterator it = _getInstance().inputStatesByName_.find(name);
+        if (it != _getInstance().inputStatesByName_.end())
+        {
+            _getInstance().stateEnterRequests_.push_back((*it).second);
+            return true;
+        }
+        return false;
+    }
+
+    bool InputManager::requestLeaveState(const std::string& name)
     {
         // get pointer from the map with all stored handlers
-        std::map<std::string, KeyHandler*>::const_iterator mapIt = _getSingleton().keyHandlers_.find(name);
-        if (mapIt == _getSingleton().keyHandlers_.end())
-            return false;
-        // look for the handler in the list
-        for (std::vector<KeyHandler*>::iterator it = _getSingleton().activeKeyHandlers_.begin();
-            it != _getSingleton().activeKeyHandlers_.end(); it++)
-        {
-            if ((*it) == (*mapIt).second)
-            {
-                _getSingleton().activeKeyHandlers_.erase(it);
-                _getSingleton().stateRequest_ = IS_CUSTOM;
-                _getSingleton()._updateTickables();
-                return true;
-            }
-        }
-        return true;
-    }
-
-    /**
-    @brief
-        Checks whether a key handler is active
-    @param name
-        Unique name of the handler.
-    @return
-        False if key handler is not active or doesn't exist, true otherwise.
-    */
-    bool InputManager::isKeyHandlerActive(const std::string& name)
-    {
-        // get pointer from the map with all stored handlers
-        std::map<std::string, KeyHandler*>::const_iterator mapIt = _getSingleton().keyHandlers_.find(name);
-        if (mapIt == _getSingleton().keyHandlers_.end())
-            return false;
-        // see whether the handler already is in the list
-        for (std::vector<KeyHandler*>::iterator it = _getSingleton().activeKeyHandlers_.begin();
-            it != _getSingleton().activeKeyHandlers_.end(); it++)
-        {
-            if ((*it) == (*mapIt).second)
-                return true;
+        std::map<std::string, InputState*>::const_iterator it = _getInstance().inputStatesByName_.find(name);
+        if (it != _getInstance().inputStatesByName_.end())
+        {
+            _getInstance().stateLeaveRequests_.push_back((*it).second);
+            return true;
         }
         return false;
     }
-
-
-    // ###### MouseHandler ######
-    /**
-    @brief
-        Adds a new mouse handler.
-    @param handler
-        Pointer to the handler object.
-    @param name
-        Unique name of the handler.
-    @return
-        True if added, false if name already existed.
-    */
-    bool InputManager::addMouseHandler(MouseHandler* handler, const std::string& name)
-    {
-        if (!handler)
-            return false;
-        if (_getSingleton().mouseHandlers_.find(name) == _getSingleton().mouseHandlers_.end())
-        {
-            _getSingleton().mouseHandlers_[name] = handler;
-            return true;
-        }
-        else
-            return false;
-    }
-
-    /**
-    @brief
-        Removes a Mouse handler from the list.
-    @param name
-        Unique name of the handler.
-    @return
-        True if removal was successful, false if name was not found.
-    */
-    bool InputManager::removeMouseHandler(const std::string &name)
-    {
-        disableMouseHandler(name);
-        std::map<std::string, MouseHandler*>::iterator it = _getSingleton().mouseHandlers_.find(name);
-        if (it != _getSingleton().mouseHandlers_.end())
-        {
-            _getSingleton().mouseHandlers_.erase(it);
-            return true;
-        }
-        else
-            return false;
-    }
-
-    /**
-    @brief
-        Returns the pointer to a handler.
-    @param name
-        Unique name of the handler.
-    @return
-        Pointer to the instance, 0 if name was not found.
-    */
-    MouseHandler* InputManager::getMouseHandler(const std::string& name)
-    {
-        std::map<std::string, MouseHandler*>::iterator it = _getSingleton().mouseHandlers_.find(name);
-        if (it != _getSingleton().mouseHandlers_.end())
-        {
-            return (*it).second;
-        }
-        else
-            return 0;
-    }
-
-    /**
-    @brief
-        Enables a specific mouse handler that has already been added.
-    @param name
-        Unique name of the handler.
-    @return
-        False if name was not found, true otherwise.
-    */
-    bool InputManager::enableMouseHandler(const std::string& name)
-    {
-        // get pointer from the map with all stored handlers
-        std::map<std::string, MouseHandler*>::const_iterator mapIt = _getSingleton().mouseHandlers_.find(name);
-        if (mapIt == _getSingleton().mouseHandlers_.end())
-            return false;
-        // see whether the handler already is in the list
-        for (std::vector<MouseHandler*>::iterator it = _getSingleton().activeMouseHandlers_.begin();
-            it != _getSingleton().activeMouseHandlers_.end(); it++)
-        {
-            if ((*it) == (*mapIt).second)
-            {
-                return true;
-            }
-        }
-        _getSingleton().activeMouseHandlers_.push_back((*mapIt).second);
-        _getSingleton().stateRequest_ = IS_CUSTOM;
-        _getSingleton()._updateTickables();
-        return true;
-    }
-
-    /**
-    @brief
-        Disables a specific mouse handler.
-    @param name
-        Unique name of the handler.
-    @return
-        False if name was not found, true otherwise.
-    */
-    bool InputManager::disableMouseHandler(const std::string &name)
-    {
-        // get pointer from the map with all stored handlers
-        std::map<std::string, MouseHandler*>::const_iterator mapIt = _getSingleton().mouseHandlers_.find(name);
-        if (mapIt == _getSingleton().mouseHandlers_.end())
-            return false;
-        // look for the handler in the list
-        for (std::vector<MouseHandler*>::iterator it = _getSingleton().activeMouseHandlers_.begin();
-            it != _getSingleton().activeMouseHandlers_.end(); it++)
-        {
-            if ((*it) == (*mapIt).second)
-            {
-                _getSingleton().activeMouseHandlers_.erase(it);
-                _getSingleton().stateRequest_ = IS_CUSTOM;
-                _getSingleton()._updateTickables();
-                return true;
-            }
-        }
-        return true;
-    }
-
-    /**
-    @brief
-        Checks whether a mouse handler is active
-    @param name
-        Unique name of the handler.
-    @return
-        False if key handler is not active or doesn't exist, true otherwise.
-    */
-    bool InputManager::isMouseHandlerActive(const std::string& name)
-    {
-        // get pointer from the map with all stored handlers
-        std::map<std::string, MouseHandler*>::const_iterator mapIt = _getSingleton().mouseHandlers_.find(name);
-        if (mapIt == _getSingleton().mouseHandlers_.end())
-            return false;
-        // see whether the handler already is in the list
-        for (std::vector<MouseHandler*>::iterator it = _getSingleton().activeMouseHandlers_.begin();
-            it != _getSingleton().activeMouseHandlers_.end(); it++)
-        {
-            if ((*it) == (*mapIt).second)
-                return true;
-        }
-        return false;
-    }
-
-
-    // ###### JoyStickHandler ######
-
-    /**
-    @brief
-        Adds a new joy stick handler.
-    @param handler
-        Pointer to the handler object.
-    @param name
-        Unique name of the handler.
-    @return
-        True if added, false if name already existed.
-    */
-    bool InputManager::addJoyStickHandler(JoyStickHandler* handler, const std::string& name)
-    {
-        if (!handler)
-            return false;
-        if (_getSingleton().joyStickHandlers_.find(name) == _getSingleton().joyStickHandlers_.end())
-        {
-            _getSingleton().joyStickHandlers_[name] = handler;
-            return true;
-        }
-        else
-            return false;
-    }
-
-    /**
-    @brief
-        Removes a JoyStick handler from the list.
-    @param name
-        Unique name of the handler.
-    @return
-        True if removal was successful, false if name was not found.
-    */
-    bool InputManager::removeJoyStickHandler(const std::string &name)
-    {
-        for (std::vector<OIS::JoyStick*>::iterator itstick = _getSingleton().joySticks_.begin();
-            itstick != _getSingleton().joySticks_.end(); itstick++)
-            disableJoyStickHandler(name, itstick - _getSingleton().joySticks_.begin());
-
-        std::map<std::string, JoyStickHandler*>::iterator it = _getSingleton().joyStickHandlers_.find(name);
-        if (it != _getSingleton().joyStickHandlers_.end())
-        {
-            _getSingleton().joyStickHandlers_.erase(it);
-            return true;
-        }
-        else
-            return false;
-    }
-
-    /**
-    @brief
-        Returns the pointer to a handler.
-    @param name
-        Unique name of the handler.
-    @return
-        Pointer to the instance, 0 if name was not found.
-    */
-    JoyStickHandler* InputManager::getJoyStickHandler(const std::string& name)
-    {
-        std::map<std::string, JoyStickHandler*>::iterator it = _getSingleton().joyStickHandlers_.find(name);
-        if (it != _getSingleton().joyStickHandlers_.end())
-        {
-            return (*it).second;
-        }
-        else
-            return 0;
-    }
-
-    /**
-    @brief
-        Enables a specific joy stick handler that has already been added.
-    @param name
-        Unique name of the handler.
-    @return
-        False if name or id was not found, true otherwise.
-    */
-    bool InputManager::enableJoyStickHandler(const std::string& name, unsigned int ID)
-    {
-        // get handler pointer from the map with all stored handlers
-        std::map<std::string, JoyStickHandler*>::const_iterator handlerIt = _getSingleton().joyStickHandlers_.find(name);
-        if (handlerIt == _getSingleton().joyStickHandlers_.end())
-            return false;
-
-        // check for existence of the ID
-        if (ID >= _getSingleton().joySticksSize_)
-            return false;
-
-        // see whether the handler already is in the list
-        for (std::vector<JoyStickHandler*>::iterator it = _getSingleton().activeJoyStickHandlers_[ID].begin();
-            it != _getSingleton().activeJoyStickHandlers_[ID].end(); it++)
-        {
-            if ((*it) == (*handlerIt).second)
-            {
-                return true;
-            }
-        }
-        _getSingleton().activeJoyStickHandlers_[ID].push_back((*handlerIt).second);
-        _getSingleton().stateRequest_ = IS_CUSTOM;
-        _getSingleton()._updateTickables();
-        return true;
-    }
-
-    /**
-    @brief
-        Disables a specific joy stick handler.
-    @param name
-        Unique name of the handler.
-    @return
-        False if name or id was not found, true otherwise.
-    */
-    bool InputManager::disableJoyStickHandler(const std::string &name, unsigned int ID)
-    {
-        // get handler pointer from the map with all stored handlers
-        std::map<std::string, JoyStickHandler*>::const_iterator handlerIt = _getSingleton().joyStickHandlers_.find(name);
-        if (handlerIt == _getSingleton().joyStickHandlers_.end())
-            return false;
-
-        // check for existence of the ID
-        if (ID >= _getSingleton().joySticksSize_)
-            return false;
-
-        // look for the handler in the list
-        for (std::vector<JoyStickHandler*>::iterator it = _getSingleton().activeJoyStickHandlers_[ID].begin();
-            it != _getSingleton().activeJoyStickHandlers_[ID].end(); it++)
-        {
-            if ((*it) == (*handlerIt).second)
-            {
-                _getSingleton().activeJoyStickHandlers_[ID].erase(it);
-                _getSingleton().stateRequest_ = IS_CUSTOM;
-                _getSingleton()._updateTickables();
-                return true;
-            }
-        }
-        return true;
-    }
-
-    /**
-    @brief
-        Checks whether a joy stick handler is active
-    @param name
-        Unique name of the handler.
-    @return
-        False if key handler is not active or doesn't exist, true otherwise.
-    */
-    bool InputManager::isJoyStickHandlerActive(const std::string& name, unsigned int ID)
-    {
-        // get handler pointer from the map with all stored handlers
-        std::map<std::string, JoyStickHandler*>::const_iterator handlerIt = _getSingleton().joyStickHandlers_.find(name);
-        if (handlerIt == _getSingleton().joyStickHandlers_.end())
-            return false;
-
-        // check for existence of the ID
-        if (ID >= _getSingleton().joySticksSize_)
-            return false;
-
-        // see whether the handler already is in the list
-        for (std::vector<JoyStickHandler*>::iterator it = _getSingleton().activeJoyStickHandlers_[ID].begin();
-            it != _getSingleton().activeJoyStickHandlers_[ID].end(); it++)
-        {
-            if ((*it) == (*handlerIt).second)
-                return true;
-        }
-        return false;
-    }
-
 }
Index: code/branches/input/src/core/input/InputManager.h
===================================================================
--- code/branches/input/src/core/input/InputManager.h	(revision 1636)
+++ code/branches/input/src/core/input/InputManager.h	(revision 1637)
@@ -41,4 +41,5 @@
 #include <map>
 #include <vector>
+#include <stack>
 #include "util/Math.h"
 #include "core/OrxonoxClass.h"
@@ -68,16 +69,4 @@
     };
 
-    /**
-    @brief
-        Struct for storing a custom input state
-    */
-    struct StoredState
-    {
-        std::vector<KeyHandler*>                    activeKeyHandlers_;
-        std::vector<MouseHandler*>                  activeMouseHandlers_;
-        std::vector<std::vector<JoyStickHandler*> > activeJoyStickHandlers_;
-        std::vector<std::pair<InputTickable*, HandlerState> > activeHandlers_;
-    };
-
     struct JoyStickCalibration
     {
@@ -95,25 +84,6 @@
         public OIS::KeyListener, public OIS::MouseListener, public OIS::JoyStickListener
     {
-    public: // enumerations
-        /**
-        @brief
-            Designates the way input is handled and redirected.
-        */
-        enum InputState
-        {
-            IS_UNINIT,    //!< InputManager has not yet been initialised.
-            IS_NONE,      //!< Input is discarded.
-            IS_NORMAL,    //!< Normal play state. Key and button bindings are active.
-            IS_GUI,       //!< All OIS input events are passed to CEGUI.
-            IS_CONSOLE,   //!< Keyboard input is redirected to the InputBuffer.
-            IS_DETECT,    //!< All the input additionally goes to the KeyDetector
-            IS_NODETECT,  //!< remove KeyDetector
-            IS_NOCALIBRATE,
-            IS_CALIBRATE,
-            IS_CUSTOM     //!< Any possible configuration.
-        };
-
-    public: // member functions
-        void setConfigValues();
+        // --> setConfigValues is private
+        friend ClassIdentifier<InputManager>;
 
     public: // static functions
@@ -139,7 +109,4 @@
         static void setWindowExtents(const int width, const int height);
 
-        static void setInputState(const InputState state);
-        static InputState getInputState();
-
         static void storeKeyStroke(const std::string& name);
         static void keyBind(const std::string& command);
@@ -149,24 +116,12 @@
         static void tick(float dt);
 
-        static bool addKeyHandler                 (KeyHandler* handler, const std::string& name);
-        static bool removeKeyHandler              (const std::string& name);
-        static KeyHandler* getKeyHandler          (const std::string& name);
-        static bool enableKeyHandler              (const std::string& name);
-        static bool disableKeyHandler             (const std::string& name);
-        static bool isKeyHandlerActive            (const std::string& name);
-
-        static bool addMouseHandler               (MouseHandler* handler, const std::string& name);
-        static bool removeMouseHandler            (const std::string& name);
-        static MouseHandler* getMouseHandler      (const std::string& name);
-        static bool enableMouseHandler            (const std::string& name);
-        static bool disableMouseHandler           (const std::string& name);
-        static bool isMouseHandlerActive          (const std::string& name);
-
-        static bool addJoyStickHandler            (JoyStickHandler* handler, const std::string& name);
-        static bool removeJoyStickHandler         (const std::string& name);
-        static JoyStickHandler* getJoyStickHandler(const std::string& name);
-        static bool enableJoyStickHandler         (const std::string& name, unsigned int id);
-        static bool disableJoyStickHandler        (const std::string& name, unsigned int id);
-        static bool isJoyStickHandlerActive       (const std::string& name, unsigned int id);
+        static SimpleInputState*   createSimpleInputState  (const std::string& name, int priority);
+        static ExtendedInputState* createExtendedInputState(const std::string& name, int priority);
+        static bool destroyState (const std::string& name);
+        //static bool removeState (const std::string& name);
+        static InputState* getState       (const std::string& name);
+        static InputState* getCurrentState();
+        static bool requestEnterState     (const std::string& name);
+        static bool requestLeaveState     (const std::string& name);
 
     private: // functions
@@ -181,4 +136,5 @@
         bool _initialiseMouse();
         bool _initialiseJoySticks();
+        void _redimensionLists();
 
         void _destroy();
@@ -186,9 +142,5 @@
         void _destroyMouse();
         void _destroyJoySticks();
-
-        void _updateTickables();
-
-        void _saveState();
-        void _restoreState();
+        void _destroyState(InputState* state);
 
         void _completeCalibration();
@@ -198,4 +150,7 @@
 
         void _tick(float dt);
+
+        void _updateActiveStates();
+        bool _configureInputState(InputState* state, const std::string& name, int priority);
 
         // input events
@@ -210,8 +165,8 @@
         bool sliderMoved   (const OIS::JoyStickEvent &arg, int id);
         bool povMoved      (const OIS::JoyStickEvent &arg, int id);
-        //bool vector3Moved  (const OIS::JoyStickEvent &arg, int id);
-
-        static InputManager& _getSingleton();
-        static InputManager* _getSingletonPtr() { return &_getSingleton(); }
+
+        void setConfigValues();
+
+        static InputManager& _getInstance();
 
     private: // variables
@@ -221,15 +176,20 @@
         std::vector<OIS::JoyStick*>                 joySticks_;       //!< OIS joy sticks
         unsigned int                                joySticksSize_;
-
-        KeyBinder*                                  keyBinder_;       //!< KeyBinder instance
-        KeyDetector*                                keyDetector_;     //!< KeyDetector instance
-        InputBuffer*                                buffer_;          //!< InputBuffer instance
-        CalibratorCallback*                         calibratorCallback_;
-
-        InputState state_;
-        InputState stateRequest_;
-        InputState savedState_;
-        unsigned int keyboardModifiers_;
-        StoredState savedHandlers_;
+        unsigned int                                devicesNum_;
+
+        // some internally handled states
+        SimpleInputState*                                 stateDetector_;   //!< KeyDetector instance
+        SimpleInputState*                                 stateCalibrator_;
+        SimpleInputState*                                 stateEmpty_;
+
+        std::map<std::string, InputState*>          inputStatesByName_;
+        std::map<int, InputState*>                  inputStatesByPriority_;
+
+        std::vector<InputState*> stateEnterRequests_;                  //!< Request to enter a new state
+        std::vector<InputState*> stateLeaveRequests_;                    //!< Request to leave the current state
+
+        std::map<int, InputState*> activeStates_;
+        std::vector<InputState*>   activeStatesTop_;    //!< Current input states for joy stick events.
+        std::vector<InputState*>   activeStatesTicked_;    //!< Current input states for joy stick events.
 
         // joystick calibration
@@ -239,5 +199,7 @@
         int marginalsMin_[24];
         bool bCalibrated_;
-
+        bool bCalibrating_;
+
+        unsigned int keyboardModifiers_;           //!< Bit mask representing keyboard modifiers
         //! Keeps track of the joy stick POV states
         std::vector<POVStates>                      povStates_;
@@ -246,13 +208,4 @@
         std::vector<JoyStickCalibration>            joySticksCalibration_;
 
-        std::map<std::string, KeyHandler*>          keyHandlers_;
-        std::map<std::string, MouseHandler*>        mouseHandlers_;
-        std::map<std::string, JoyStickHandler*>     joyStickHandlers_;
-
-        std::vector<KeyHandler*>                    activeKeyHandlers_;
-        std::vector<MouseHandler*>                  activeMouseHandlers_;
-        std::vector<std::vector<JoyStickHandler*> > activeJoyStickHandlers_;
-        std::vector<std::pair<InputTickable*, HandlerState> > activeHandlers_;
-
         std::vector<Key>                            keysDown_;
         std::vector<MouseButton::Enum>              mouseButtonsDown_;
